bin_packages/urls.py
from django.urls import path

from bin_packages import views


app_name = 'bin_packages'
urlpatterns = [
    path('', views.index, name='index'),
    path('<name>', views.detail, name='detail'),
]

hosts/urls.py
from django.urls import path

from hosts import views


app_name = 'hosts'
urlpatterns = [
    path('', views.index, name='index'),
    path('<name>', views.DetailView.as_view(), name='detail'),
    path('<name>/update', views.update, name='update'),
]

images/urls.py
from django.urls import path

from images import views


app_name = 'images'
urlpatterns = [
    path('', views.index, name='index'),
    path('<path:name>/update', views.update_image, name='update'),
    path('<path:name>', views.DetailView.as_view(), name='detail'),
]

src_packages/urls.py
from django.urls import path

from src_packages import views


app_name = 'src_packages'
urlpatterns = [
    path('', views.index, name='index'),
    path('<name>', views.detail, name='detail'),
]

bin_packages/models.py
from django.core.exceptions import ValidationError
from django.db import models

from debmonitor import SelectManager
from src_packages.models import OS, SrcPackageVersion


class Package(models.Model):
    """Binary package model."""

    name = models.CharField(max_length=255, unique=True, help_text='Binary package name.')

    class Meta:
        """Additional metadata."""

        ordering = ['name']
        verbose_name = 'package'
        verbose_name_plural = 'packages'

    def __str__(self):
        """Model representation."""
        return self.name


class PackageVersionManager(SelectManager):
    """Manager class for the PackageVersion model."""

    def get_or_create(self, **kwargs):
        """Override parent method to lazily create the missing objects."""
        arguments = {'version': kwargs['version'], 'os': kwargs['os']}
        if ('host_package' in kwargs and kwargs['host_package'] is not None and
                kwargs['host_package'].package_version.src_package_version.src_package.name == kwargs['source']):
            # Use already queried objects
            arguments['package'] = kwargs['host_package'].package_version.package
            src_package = kwargs['host_package'].package_version.src_package_version.src_package
        else:
            arguments['package'], _ = Package.objects.get_or_create(name=kwargs['name'])
            src_package = None

        arguments['src_package_version'], _ = SrcPackageVersion.objects.get_or_create(
            name=kwargs['source'], version=kwargs['version'], os=kwargs['os'], src_package=src_package)

        return super().get_or_create(**arguments)


class PackageVersion(models.Model):
    """Binary package version model."""

    package = models.ForeignKey(Package, on_delete=models.PROTECT, db_index=False, related_name='versions',
                                help_text='Binary package.')
    version = models.CharField(max_length=255, help_text='Binary package version.')
    os = models.ForeignKey(OS, on_delete=models.PROTECT, db_index=False, related_name='+',
                           verbose_name='operating system', help_text='Operating system.')
    src_package_version = models.ForeignKey(
        SrcPackageVersion, on_delete=models.PROTECT, related_name='binaries', verbose_name='source package version',
        help_text='Source package version that generated this binary package version.')
    created = models.DateTimeField(auto_now_add=True, help_text='Datetime of the creation of this object.')
    modified = models.DateTimeField(auto_now=True, help_text='Datetime of the last modification of this object.')

    objects = PackageVersionManager(
        _select_related=['package', 'os', 'src_package_version', 'src_package_version__src_package'])

    class Meta:
        """Additional metadata."""

        ordering = ['package__name', 'version']
        unique_together = ('package', 'version', 'os')
        verbose_name = 'package version'
        verbose_name_plural = 'package versions'

    def __str__(self):
        """Model representation."""
        return '{name} {version} ({os})'.format(name=self.package.name, version=self.version, os=self.os.name)

    def clean(self):
        """Validate the model fields."""
        if self.os != self.src_package_version.os:
            raise ValidationError('OS mismatch between {src} and {bin}.'.format(
                src=str(self.src_package_version), bin=str(self)))

    def save(self, *args, **kwargs):
        """Override parent save() to force validation."""
        self.full_clean()
        super().save(*args, **kwargs)

bin_packages/views.py
import json

from collections import defaultdict, OrderedDict

from django.db.models import Count
from django.http import Http404
from django.shortcuts import render
from django.views.decorators.http import require_safe

from bin_packages.models import Package, PackageVersion
from debmonitor import DistinctGroupConcat
from hosts.models import HostPackage, SECURITY_UPGRADE
from images.models import ImagePackage


def _count_items_per_package(model, count_field, filters=None):
    """Return a dictionary with package as key and the count of field items as value for all packages."""
    if filters is None:
        filters = {}

    return {row[count_field]: row['count'] for row in model.objects.select_related(None).filter(**filters).values(
        count_field).annotate(count=Count(count_field)).order_by()}


def _count_items_per_version(model, package_id, count_field, filters=None):
    """Return a dictionary with package version as key and the count of field items as value for a given package."""
    exclude = {'{field}__isnull'.format(field=count_field): True}
    if filters is None:
        filters = {}

    return {row[count_field]: row['count'] for row in model.objects.select_related(None).filter(
        package=package_id, **filters).exclude(**exclude).values(count_field).annotate(count=Count(
            count_field)).order_by()}


@require_safe
def index(request):
    """Binary packages list page."""
    packages = Package.objects.annotate(
        versions_count=Count('versions', distinct=True),
        os_list=DistinctGroupConcat('versions__os__name'))

    # Get all the additional annotations separately for query optimization purposes
    package_annotations = {'hosts': {}, 'images': {}}
    package_annotations['hosts']['inst_count'] = _count_items_per_package(HostPackage, 'package')
    package_annotations['hosts']['upgrades_count'] = _count_items_per_package(HostPackage, 'upgradable_package')
    package_annotations['hosts']['security_count'] = _count_items_per_package(
        HostPackage, 'upgradable_package', filters={'upgrade_type': SECURITY_UPGRADE})
    package_annotations['images']['inst_count'] = _count_items_per_package(ImagePackage, 'package')
    package_annotations['images']['upgrades_count'] = _count_items_per_package(ImagePackage, 'upgradable_imagepackage')
    package_annotations['images']['security_count'] = _count_items_per_package(
        ImagePackage, 'upgradable_imagepackage', filters={'upgrade_type': SECURITY_UPGRADE})

    # Insert all the annotated data back into the package objects for easy access in the templates
    for package in packages:
        for annotation in ('inst_count', 'upgrades_count', 'security_count'):
            setattr(package, annotation, package_annotations['hosts'][annotation].get(package.id, 0)
                    + package_annotations['images'][annotation].get(package.id, 0))

    table_headers = [
        {'title': 'Package', 'tooltip': 'Name of the binary package', 'badges': [
         {'style': 'primary', 'tooltip': 'Number of hosts/images that have this package installed'},
         {'style': 'warning',
          'tooltip': 'Number of hosts/images that have this package installed and are pending an upgrade'},
         {'style': 'danger',
          'tooltip': 'Number of hosts/images that have this package installed and are pending a security upgrade'}]},
        {'title': '# Versions',
         'tooltip': 'Number of distinct installed versions of this package between all the hosts/images'},
        {'title': 'OSes',
         'tooltip': 'List of distinct operating systems the hosts/images that have this package installed are running'},
        {'title': '# Hosts'},
        {'title': '# Upgrades'},
        {'title': '# Security Upgrades'},
    ]

    args = {
        # The IDs are DataTable column IDs.
        'custom_sort': {'name': 'Package', 'installed': 3, 'upgrades': 4, 'security': 5},
        'datatables_column_defs': json.dumps([
            {'targets': [3, 4, 5], 'visible': False},
            {'targets': [1, 2, 3, 4, 5], 'searchable': False},
            {'targets': [3, 4, 5], 'sortable': False}]),
        'datatables_page_length': 50,
        'packages': packages,
        'section': 'bin_packages',
        'subtitle': '',
        'table_headers': table_headers,
        'title': 'Binary Packages',
    }
    return render(request, 'bin_packages/index.html', args)


@require_safe
def detail(request, name):
    """Binary package detail page."""
    package_versions = PackageVersion.objects.filter(package__name=name)
    if not package_versions:
        raise Http404

    package_id = package_versions[0].package
    counters = {'hosts': {}, 'images': {}}
    counters['hosts']['package_version'] = _count_items_per_version(HostPackage, package_id, 'package_version')
    counters['hosts']['upgradable_version'] = _count_items_per_version(HostPackage, package_id, 'upgradable_version')
    counters['hosts']['security_upgrades'] = _count_items_per_version(
        HostPackage, package_id, 'upgradable_version', filters={'upgrade_type': SECURITY_UPGRADE})
    counters['images']['package_version'] = _count_items_per_version(ImagePackage, package_id, 'package_version')
    counters['images']['upgradable_version'] = _count_items_per_version(
        ImagePackage, package_id, 'upgradable_imageversion')
    counters['images']['security_upgrades'] = _count_items_per_version(
        ImagePackage, package_id, 'upgradable_imageversion', filters={'upgrade_type': SECURITY_UPGRADE})

    host_packages = HostPackage.objects.filter(package__name=name)
    image_packages = ImagePackage.objects.filter(package__name=name)

    os_versions = OrderedDict()
    src_packages_versions = set()
    for package_version in package_versions:
        os = package_version.os.name
        ver = package_version.version
        ver_id = package_version.id

        if os not in os_versions:
            os_versions[os] = {'versions': OrderedDict(), 'totals': {}}

        os_versions[os]['versions'][ver] = defaultdict(int)
        os_versions[os]['versions'][ver]['installed'] += (
            counters['hosts']['package_version'].get(ver_id, 0)
            + counters['images']['package_version'].get(ver_id, 0))
        os_versions[os]['versions'][ver]['upgradable'] += (
            counters['hosts']['upgradable_version'].get(ver_id, 0)
            + counters['images']['upgradable_version'].get(ver_id, 0))
        os_versions[os]['versions'][ver]['security'] += (
            counters['hosts']['security_upgrades'].get(ver_id, 0)
            + counters['images']['security_upgrades'].get(ver_id, 0))

        src_packages_versions.add(package_version.src_package_version.src_package.name)

    for os_data in os_versions.values():
        totals = defaultdict(int)
        for counter in os_data['versions'].values():
            totals['installed'] += counter['installed']
            totals['upgradable'] += counter['upgradable']
            totals['security'] += counter['security']
        os_data['totals'] = totals

    table_headers = [
        {'title': 'OS'},
        {'title': 'Version'},
        {'title': 'Hostname/Image name', 'tooltip':
         'Host/image that have this specific combination of OS and version installed'},
        {'title': 'Upgradable to', 'tooltip': 'Version to which the package can be upgraded to'},
        {'title': 'Upgrade Type'},
    ]

    args = {
        # The IDs are DataTable column IDs.
        'column_groups': [
            {'column': 0, 'title': 'OS', 'css_group': 1,
             'tooltip': 'Number of hosts/images that have this package and OS installed'},
            {'column': 1, 'title': 'Version', 'css_group': 2,
             'tooltip': 'Number of hosts/images that have this specific package version and OS installed'},
        ],
        'default_order': json.dumps([[0, 'asc'], [1, 'asc']]),
        'datatables_column_defs': json.dumps([
            {'targets': [0, 1], 'searchable': False},
            {'targets': [0, 1, 3, 4], 'sortable': False},
            {'targets': [0, 1, 4], 'visible': False},
        ]),

        'datatables_page_length': 50,
        'host_packages': host_packages,
        'image_packages': image_packages,
        'os_versions': os_versions,
        'package_versions': package_versions,
        'section': 'bin_packages',
        'src_packages_versions': src_packages_versions,
        'subtitle': 'Binary Package',
        'table_headers': table_headers,
        'title': name,
        'upgrades_column': 3,
    }
    return render(request, 'bin_packages/detail.html', args)

templates/bin_packages/detail.html
{% extends "../base_table.html" %}

{% block summary %}
<dl class="row">
  <dt class="col-sm-3">Source Packages</dt>
  <dd class="col-sm-9">
    {% for version in src_packages_versions %}
    <a href="{% url 'src_packages:detail' version %}">{{ version }}</a>{% if not forloop.last %}, {% endif %}
    {% endfor %}
  </dd>
  {% for os, data in os_versions.items %}
  <dt class="col-sm-3">
    <div class="text-nowrap">
      {{ os }} versions
      {% if data.totals.installed %}
      <span data-toggle="tooltip" title="Number of hosts that have this package installed">
        <span class="badge badge-primary align-text-bottom">{{ data.totals.installed }}</span>
      </span>
      {% endif %}
      {% if data.totals.upgradable %}
      <span data-toggle="tooltip" title="Number of hosts that have this package installed and are pending an upgrade">
        <span class="badge badge-warning align-text-bottom">{{ data.totals.upgradable }}</span>
      </span>
      {% endif %}
      {% if data.totals.security %}
      <span data-toggle="tooltip" title="Number of hosts that have this package installed and are pending a security upgrade">
        <span class="badge badge-danger align-text-bottom">{{ data.totals.security }}</span>
      </span>
      {% endif %}
    </div>
  </dt>
  <dd class="col-sm-9">
      {% for version, counters in data.versions.items %}
        {% spaceless %}
        {{ version }}
        {% if counters.installed %}
        <span data-toggle="tooltip" title="Number of hosts that have this version installed">
          <span class="badge badge-primary align-text-bottom{% if counters.upgradable %} mr-1{% endif %}">{{ counters.installed }}</span>
        </span>
        {% endif %}
        {% if counters.upgradable %}
        <span data-toggle="tooltip" title="Number of hosts that have this package installed and are pending an upgrade to this version">
          <span class="badge badge-warning align-text-bottom{% if counters.security %} mr-1{% endif %}">{{ counters.upgradable }}</span>
        </span>
        {% endif %}
        {% if counters.security %}
        <span data-toggle="tooltip" title="Number of hosts that have this package installed and are pending a security upgrade to this version">
          <span class="badge badge-danger align-text-bottom">{{ counters.security }}</span>
        </span>
        {% endif %}
        {% if not forloop.last %}, {% endif %}
        {% endspaceless %}
      {% endfor %}
  </dd>
  {% endfor %}
</dl>
{% endblock %}

{% block table_body %}
{% for host_package in host_packages %}
<tr>
  <td>{{ host_package.host.os.name }}</td>
  <td>{{ host_package.package_version.version }}</td>
  <td>
    <a href="{% url 'hosts:detail' host_package.host.name %}">{{ host_package.host.name }} (host)</a>
  </td>
  <td>
    {% if host_package.upgradable_version.version %}
    {{ host_package.upgradable_version.version }}
      {% if host_package.upgrade_type == security_upgrade %}
      <span class="badge badge-danger align-text-bottom">security</span>
      {% else %}
      <span class="badge badge-warning align-text-bottom">upgrade</span>
      {% endif %}
    {% endif %}
  </td>
  <td>{% if host_package.upgrade_type %}{{ host_package.upgrade_type }}{% endif %}</td>
</tr>
{% endfor %}

{% for image_package in image_packages %}
<tr>
  <td>{{ image_package.image.os.name }}</td>
  <td>{{ image_package.package_version.version }}</td>
  <td>
    <a href="{% url 'images:detail' image_package.image.name %}">{{ image_package.image.name }} (image)</a>
  </td>
  <td>
    {% if image_package.upgradable_imageversion.version %}
    {{ image_package.upgradable_imageversion.version }}
      {% if image_package.upgrade_type == security_upgrade %}
      <span class="badge badge-danger align-text-bottom">security</span>
      {% else %}
      <span class="badge badge-warning align-text-bottom">upgrade</span>
      {% endif %}
    {% endif %}
  </td>
  <td>{% if image_package.upgrade_type %}{{ image_package.upgrade_type }}{% endif %}</td>
</tr>
{% endfor %}
{% endblock %}

templates/bin_packages/index.html
{% extends "../base_table.html" %}

{% block table_body %}
{% for package in packages %}
<tr>
  <td>
    <div class="row">
      <div class="col-md-8"><a href="{% url 'bin_packages:detail' package.name %}">{{ package.name }}</a></div>
      <div class="col-md-4">
        {% if package.inst_count %}<span class="badge badge-primary align-text-bottom" data-toggle="tooltip" data-trigger="hover" data-delay='{"show": 800, "hide": 50}' title="{{ table_headers.0.badges.0.tooltip }}" aria-pressed="true">{{ package.inst_count }}</span>{% endif %}
        {% if package.upgrades_count %}<span class="badge badge-warning align-text-bottom" data-toggle="tooltip" data-trigger="hover" data-delay='{"show": 800, "hide": 50}' title="{{ table_headers.0.badges.1.tooltip }}" aria-pressed="true">{{ package.upgrades_count }}</span>{% endif %}
        {% if package.security_count %}<span class="badge badge-danger align-text-bottom" data-toggle="tooltip" data-trigger="hover" data-delay='{"show": 800, "hide": 50}' title="{{ table_headers.0.badges.2.tooltip }}" aria-pressed="true">{{ package.security_count }}</span>{% endif %}
      </div>
    </div>
  </td>
  <td>{{ package.versions_count }}</td>
  <td>{{ package.os_list }}</td>
  <td>{{ package.inst_count }}</td>
  <td>{{ package.upgrades_count }}</td>
  <td>{{ package.security_count }}</td>
</tr>
{% endfor %}
{% endblock %}